// User defined constants

const myToolbarName = "TUVBar"; //
const myToolbarId = "tuvtoolbar"; // <toolbar>'s id


/* toolbar interface

Method List

DisplayCheck()       Checks if the current window has the location bar hidden, and if yes, hides the toolbar
LoadPage(url)        Loads the url in active window/tab
Uninstall            Uninstalls the toolbar.
*/

function tuvtoolbar() {
  this.myToolbarId = myToolbarId;
};

function showLinks(urlx) {
 var x,n,nD,z,i; function htmlEscape(s){s=s.replace(/&/g,'&amp;');s=s.replace(/>/g,'&gt;');s=s.replace(/</g,'&lt;');return s;} function attrQuoteEscape(s){s=s.replace(/&/g,'&amp;'); s=s.replace(/"/g, '&quot;');return s;}; n=0; if(x!=null) { x=x.toLowerCase(); nD = window.open().document; nD.writeln('<html><head><title>Links containing "'+htmlEscape(x)+'"</title><base target="_blank"></head><body>'); nD.writeln('Links on <a href="'+attrQuoteEscape(location.href)+'">'+htmlEscape(location.href)+'</a><br> with link text or target url containing &quot;' + htmlEscape(x) + '&quot;<br><hr>'); z = document.links; for (i = 0; i < z.length; ++i) { if ((z[i].innerHTML && z[i].innerHTML.toLowerCase().indexOf(x) != -1) || z[i].href.toLowerCase().indexOf(x) != -1 ) { nD.writeln(++n + '. <a href="' + attrQuoteEscape(z[i].href) + '">' + (z[i].innerHTML || htmlEscape(z[i].href)) + '</a><br>'); } } nD.writeln('<hr></body></html>'); nD.close(); } }

function readCookie(name) {
    //needed for cookie-killer
    // if there's no cookie, go no further
    if(window.location.document.cookie == '') {
        return false;
    } else {
        // if there is a cookie...
        var firstChar, lastChar;
        var theBigCookie = window.location.document.cookie;
        // find the start of 'name'
        firstChar = theBigCookie.indexOf(name);
        var NN2Hack = firstChar + name.length;
        // if you found the cookie...
        if((firstChar != -1) && (theBigCookie.charAt(NN2Hack) == '=')) {
            // skip 'name' and '='
            firstChar += name.length + 1;
            // Find the end of the value string (i.e. the next ';').
            lastChar = theBigCookie.indexOf(';', firstChar);
            if(lastChar == -1) lastChar = theBigCookie.length;
            return unescape(theBigCookie.substring(firstChar, lastChar));
        } else {
            // If there was no cookie of that name, return false.
            return false;
        }
    }
}

function killCookie(name, path, domain) {
    //needed for cookie-killer
    // get the value for this cookie
    var domain=window.location.document.domain;
   alert("domain: " + domain);
   alert("cookiename= " + name);
   alert("cookiepath= " + path);
    var theValue = readCookie(name);
    if(theValue) {
        //if there was a value...
        // set an already-expired cookie
        window.location.document.cookie = name + '=' + escape(theValue)
            + '; expires=Fri, 13-Apr-1970 00:00:00 GMT'
            + ((path)?';path=' + path:'')
            + ((domain)?';domain=' + domain:'');
    }
}

function stripurl(ourl) {
		// get home-url
	CutURL=ourl;
	// check, if questionmark is present in url
	QMarkPos = CutURL.indexOf("?");
	//if QMark is present, get position and cut everything behind
	if (QMarkPos > 0)   	{
	CutURL = CutURL.substring(0, QMarkPos);
    	}
	//kill the http:// out of the url
	empty="";
	var CutURL = CutURL.replace(/http/, '');
	var CutURL = CutURL.replace(/\%3A/, '');
	var CutURL = CutURL.replace(/\/\//, '');
	var CutURL = CutURL.replace(/\:/, '');

	//kill the path out of the url
	QMarkPos = CutURL.indexOf("/");

	//if Slash is present, get position and cut everything behind
	if (QMarkPos > 0)   	{
	ourl = CutURL.substring(0, QMarkPos);
		}
	return ourl;}

function stripwww(ourl) {
	//kill the www:// out of the url
	empty="";
	var ourl = ourl.replace(/www./, '');
	return ourl;}

function striptld(ourl) {
	// check, if dot is present in url
	QMarkPos = ourl.indexOf(".");
	//if dot is present, get position and cut everything behind
	if (QMarkPos > 0)   	{
		ourl = ourl.substring(0, QMarkPos);
    		}
	return ourl;}


tuvtoolbar.prototype.DisplayCheck = function (){
  var main = document.getElementById("main-window");
  var myToolbar = document.getElementById(myToolbarId);

  if (main.hasAttribute("chromehidden") && (myToolbar != null)) {
    if (main.getAttribute("chromehidden").indexOf("location") != -1) {
      myToolbar.setAttribute("collapsed", "true");
      myToolbar.setAttribute("hidden", "true");
    }
  }
}

tuvtoolbar.prototype.LoadPage = function(url){
  window.content.document.location.href=url;
}



tuvtoolbar.prototype.LoadPageInTab = function(url){
  getBrowser().addTab(url);
}

tuvtoolbar.prototype.StripLoadPageInTab = function(firsturl, midurl, lasturl){
 midurl=stripurl(midurl);
 getBrowser().addTab(firsturl+midurl+lasturl);
}
tuvtoolbar.prototype.wwwStripLoadPageInTab = function(firsturl, midurl, lasturl){
 midurl=stripurl(midurl);
 midurl=stripwww(midurl);
 getBrowser().addTab(firsturl+midurl+lasturl);
}
tuvtoolbar.prototype.wwwtldStripLoadPageInTab = function(firsturl, midurl, lasturl){
 midurl=stripurl(midurl);
 midurl=stripwww(midurl);
 midurl=striptld(midurl);
 getBrowser().addTab(firsturl+midurl+lasturl);
}

tuvtoolbar.prototype.attachStyleSheetToElm = function(elm,uri,id){
  // define the new link element
  var linkElm = window.content.document.createElement("link");
  linkElm.id = id;
  linkElm.href = uri;
  linkElm.rel = "stylesheet"; linkElm.type = "text/css";
  // attach it to the given element
  try {
    elm.document.documentElement.childNodes[0].appendChild(linkElm);
  } catch(err) {
  	alert("could not attach style sheet: "+err);
  }

  // if element has frames
  if (elm.document.frames && (elm.document.frames.length>0)) {
    for (var i=0;i<elm.document.frames.length;i++) {
      tuvtoolbar.attachStyleSheetToElm(elm.document.frames[i],uri,id);
    }
  }

}
tuvtoolbar.prototype.removeStyleSheetFromElm = function(elm,uri,id){
  window.content.document.getElementById(id).parentNode.removeChild(window.content.document.getElementById(id));
}



tuvtoolbar.prototype.attachStyleSheet = function(uri,id){
  var linkElm = window.content.document.createElement("link");
  linkElm.id = id;
  linkElm.href = uri;
  linkElm.rel = "stylesheet"; linkElm.type = "text/css";
  // attach it to the page
  window.content.document.documentElement.childNodes[0].appendChild(linkElm);
}

tuvtoolbar.prototype.removeStyleSheet = function(uri,id){
  if (window.content.document.getElementById(id) != null) {
    window.content.document.getElementById(id).parentNode.removeChild(window.content.document.getElementById(id));
  }
}

tuvtoolbar.prototype.showBlocks = function(elm){
  if (elm.getAttribute("checked")) {
    window.addEventListener("unload",tuvLoadListener, true);
    tuvtoolbar.attachStyleSheetToElm(window.content,"chrome://tuvbar/content/tuvbarShowBlocks.css","tuvbarShowBlocksCSS");
  } else {
    ruvbar.removeStyleSheet("chrome://tuvbar/content/tuvbarShowBlocks.css","tuvbarShowBlocksCSS");
  }
}

tuvtoolbar.prototype.showTableCells = function(elm){
  if (elm.getAttribute("checked")) {
    window.addEventListener("unload",tuvLoadListener, true);
    tuvtoolbar.attachStyleSheet("chrome://tuvbar/content/tuvbarTableCells.css","tuvbarTableCellsCSS");
  } else {
    tuvtoolbar.removeStyleSheet("chrome://tuvbar/content/tuvbarTableCells.css","tuvbarTableCellsCSS");
  }
}

tuvtoolbar.prototype.show_hidden=function(url){
	//shows hidden form-fields
	var i,f,j,e,div,label,ne;
	for(i=0;f=window.content.document.forms[i];++i)for(j=0;e=f[j];++j)if(e.type=="hidden"){
		D=window.content.document;
		function C(t){return D.createElement(t);}
		function A(a,b){a.appendChild(b);}
		div=C("div");
		label=C("label");
		A(div, label);
		A(label, D.createTextNode(e.name + ": "));
		e.parentNode.insertBefore(div, e);
		e.parentNode.removeChild(e);
		ne=C("input");
		/*for ie*/
		ne.type="text";
		ne.value=e.value;
		A(label, ne);
		label.style.MozOpacity=".8";
		 --j;
		 /*for moz*/
		 }};

tuvtoolbar.prototype.kill_maxlength=function(url){
	//removes the maxlength-limit from form-fields
	var x,k,f,j;
	x=window.content.document.forms;
	for(k=0;k<x.length;++k){
		f=x[k];
		for(j=0;j<f.length;++j)f[j].removeAttribute("maxLength");
		}
	alert("MaxLength removed form " + x.length + "forms!");
	};


tuvtoolbar.prototype.post_to_get=function(url){
	//changes method of forms from post to get - if you send the form, you see the sent data
	//in the url. carefull: some forms won't work with GET (you see the sent data anyway)
	var x,i;
	x = window.content.document.forms;
	for (i = 0; i < x.length; ++i) x[i].method="get";
	alert("Changed " + x.length + " forms to use the GET method.");
	};

tuvtoolbar.prototype.list_links=function(url){
	//creates a new tab with all links on the page
	var x,k,f,j,links,y;
	x=window.content.document.links;
	for(k=0;k<x.length;++k){
		f=x[k];
		y=" / "
		links=links + f.href + y + f.title + y + f.rev + y + f.rel + y + f.type + y + f.media + " ## ";
		}
	//alert(links);
	//alert("MaxLength removed form " + x.length + "forms!");
	LoadPageInTab('');
	write(links);
	};


tuvtoolbar.prototype.set_ua=function(url){
	//sets the user-agent to a user-defined value
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService)
	pref = pref.getBranch("");
  	pref.setCharPref('general.useragent.override', url);
  	alert("useragent string is now: "+navigator.userAgent + " - Remember to reset the ua before shutdown - otherwise mozilla might complain about plugins!");
}

tuvtoolbar.prototype.set_proxy=function(hthost,htport,hshost,hsport,typ){
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	pref = pref.getBranch("");

	//activates and sets http-proxy
	pref.setIntPref('network.proxy.type', typ);
	pref.setCharPref('network.proxy.http', hthost);
	pref.setIntPref('network.proxy.http_port', htport);
	pref.setCharPref('network.proxy.ssl', hshost);
	pref.setIntPref('network.proxy.ssl_port', hsport);
	//alert("Proxy Set");
}

tuvtoolbar.prototype.set_proxy=function(){
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	pref = pref.getBranch("");

	//activates and sets http-proxy
	pref.setIntPref('network.proxy.type', typ);
	pref.setCharPref('network.proxy.http', hthost);
	pref.setIntPref('network.proxy.http_port', htport);
	pref.setCharPref('network.proxy.ssl', hshost);
	pref.setIntPref('network.proxy.ssl_port', hsport);
	//alert("Proxy Set");
}


tuvtoolbar.prototype.show_date=function(){
	//shows date of webpage as reflected by server (last-modified-header)
	function sDqUikyQKC(w,p){
		var i,t='';
		for(i=0;i<w.frames.length;i++)t+=sDqUikyQKC(w.frames[i],p+'    ');
		return(p+w.window.content.document.lastModified+ (w.name?(' ('+w.name+')'):'')+'\n'+t);}alert('Last modified:\n\n'+sDqUikyQKC(window,''))
	}

tuvtoolbar.prototype.kill_events=function(){
	//kills annoying eventhandlers onmouseover, onmouseout, onunload, and onresize
	var H=["mouseover","mouseout","unload","resize"],o=window.opera;
	if(document.addEventListener/*MOZ*/&&!o) for(j in H)document.addEventListener(H[j],function(e){e.stopPropagation();},true);
		else if(window.captureEvents/*NS4*/&&!o) { document.captureEvents(-1/*ALL*/);
			for(j in H)window["on"+H[j]]=null;}
		else/*IE*/ {function R(N){var i,x;for(j in H)if(N["on"+H[j]]/*NOT TEXTNODE*/)N["on"+H[j]]=null;for(i=0;x=N.childNodes[i];++i)R(x);}
		R(document);}
	}


tuvtoolbar.prototype.showReplaced = function(elm){
  if (elm.getAttribute("checked")) {
    window.addEventListener("unload",tuvLoadListener, true);
    tuvtoolbar.attachStyleSheet("chrome://tuvbar/content/tuvbarReplaced.css","tuvbarReplacedCSS");
  } else {
    tuvtoolbar.removeStyleSheet("chrome://tuvbar/content/tuvbarReplaced.css","tuvbarReplacedCSS");
  }
}

tuvtoolbar.prototype.hideImages = function(elm){
  // kill images
  for (var i=0;i<window.content.document.getElementsByTagName("img").length;i++) {
    window.content.document.getElementsByTagName("img")[i].src = ".";
  }
  tuvtoolbar.attachStyleSheet("chrome://tuvbar/content/tuvbarNoImages.css","tuvbarNoImagesCSS");
}

tuvtoolbar.prototype.applyExternalStyles = function(){
  var uri = prompt("Enter URI of New Style Sheet:","http://");
  tuvtoolbar.attachStyleSheet(uri,"tuvbarRandom"+Math.floor(Math.random()*10000));
}

tuvtoolbar.prototype.showFormDetails = function() {
  // turn hidden form fields into text inputs
  for (var i=0;i<window.content.document.getElementsByTagName("input").length;i++) {
    if (window.content.window.content.document.getElementsByTagName("input")[i].getAttribute("type") == "hidden") {
      window.content.document.getElementsByTagName("input")[i].setAttribute("type","text");
      window.content.document.getElementsByTagName("input")[i].setAttribute("className","tuvHiddenText");
      window.content.document.getElementsByTagName("input")[i].setAttribute("disabled","true");
    }
  }
  tuvtoolbar.attachStyleSheet("chrome://tuvbar/content/tuvbarFormDetails.css","tuvbarFormDetailsCSS");
}

tuvtoolbar.prototype.xreset_ua=function(){
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	pref = pref.getBranch("");
	pref.setCharPref('general.useragent.override',"");
	pref.clearUserPref('general.useragent.override');
	alert("Useragent string reset to "+navigator.userAgent);
}

tuvtoolbar.prototype.toggleStyles = function(elm){
  if (elm.getAttribute("checked")) {
    window.addEventListener("unload",tuvLoadListener, true);
    for (var i=0; i<window.content.window.content.document.styleSheets.length; i++) {
      window.content.window.content.document.styleSheets.item(i).disabled = true;
    }
  } else {
    for (var i=0; i<window.content.window.content.document.styleSheets.length; i++) {
      window.content.window.content.document.styleSheets.item(i).disabled = false;
    }
  }
}

tuvtoolbar.prototype.clearAllCache = function(){
	clearCache(Components.interfaces.nsICache.STORE_IN_MEMORY);
	clearCache(Components.interfaces.nsICache.STORE_ON_DISK);
	}

tuvtoolbar.prototype.clearMemCache = function(){
	clearCache(Components.interfaces.nsICache.STORE_IN_MEMORY);
	}

tuvtoolbar.prototype.clearDiskCache = function(){
	clearCache(Components.interfaces.nsICache.STORE_ON_DISK);
	}

tuvtoolbar.prototype.clearHistory = function(){
	var classID = Components.classes['@mozilla.org/browser/global-history;1'];
	var browserHistory = classID.getService(Components.interfaces.nsIBrowserHistory)
	browserHistory.removeAllPages();
	}

tuvtoolbar.prototype.clearLocationBar = function(){
	var classID = Components.classes['@mozilla.org/browser/urlbarhistory;1']
	var urlbarHistory = classID.getService(Components.interfaces.nsIUrlbarHistory)
	urlbarHistory.clearHistory();
	navigator.preference('general.open_location.last_url', '');
}




tuvtoolbar.prototype.showPageCookies = function(){
  if (window.content.document.cookie.length > 0) {
    alert("Gesetzte Cookies:\n"+unescape(window.content.document.cookie.split('; ').join('\n')));
  } else {
    alert("There are no cookies for this page");
  }
}

/* Clear state from page specific menu items. Currently this means just uncheck
     all the menu items, even though it means some residue will be left behind */
tuvtoolbar.prototype.clearMenu = function(){
  for (var i=0; i<document.getElementById("tuvbar").getElementsByTagName("menuitem").length; i++){
    if (document.getElementById("tuvbar").getElementsByTagName("menuitem")[i].getAttribute("type") == "checkbox") {
      document.getElementById("tuvbar").getElementsByTagName("menuitem")[i].setAttribute("checked",false);
    }
  }
}


/* Listens for page loads inside content area and if one is an unload then call
     for page specific menu items that hold state to be cleared */
function tuvLoadListener(e){
  if (e.target.getAttribute("id") == "content") {
    tuvtoolbar.clearMenu();
    window.removeEventListener("unload",tuvLoadListener,true);
  }
}














// Uninstall *******
tuvtoolbar.prototype.Uninstall = function(url){
  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  var confirmUninstall = confirm("Do you want to uninstall " + myToolbarName+ " ?" );

  if (!confirmUninstall) // user choose to cancel
    return;

  // remove the toolbar
  var myToolBar = document.getElementById(myToolbarId);
  myToolBar.parentNode.removeChild(myToolBar);

  // remove the view menu entry
  var myViewMenuEntry = document.getElementById("view_"+myToolbarId+"_menuitem");
  myViewMenuEntry.parentNode.removeChild(myViewMenuEntry);

  //remove the overlay entry in overlays.rdf

  var CONTAINER_NAME  = "chrome://browser/content/browser.xul";
  var NODE_NAME       = "chrome://"+myToolbarId+"/content/"+myToolbarId+"Overlay.xul";

  var dirServ = Components.classes['@mozilla.org/file/directory_service;1'].createInstance();
  dirServ = dirServ.QueryInterface(Components.interfaces.nsIProperties);
  var processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
  processDir.append("overlayinfo");
  processDir.append("navigator");
  processDir.append("content");
  processDir.append("overlays.rdf");

  removeRDFContainer(processDir, CONTAINER_NAME, NODE_NAME);

  // remove chrome.rdf entries

  CONTAINER_NAME = 'urn:mozilla:package:root';
  NODE_NAME = 'urn:mozilla:package:'+myToolbarId;

  processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
  processDir.append("chrome.rdf");

  // removeRDFDescription(processDir, CONTAINER_NAME, NODE_NAME);
  removeRDFContainer(processDir, CONTAINER_NAME, NODE_NAME);

  // remove the installed-chrome.txt entries - thanks to HJ for the code
  processDir = dirServ.get("AChrom", Components.interfaces.nsIFile);
  processDir.append("installed-chrome.txt");

  var entries = ReadFrom(processDir);
  entries = entries.replace(new RegExp('[^\\n\\r]+'+"resource:/chrome/"+myToolbarId+".jar!/content/"+'[\\n\\r]+', 'g'), '');
  WriteTo(processDir, entries);

  function removeRDFContainer(fileRef, containerName, nodeName){
     netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
    var C                       = Components;
    const RDF_SRVC_PROG_ID      = '@mozilla.org/rdf/rdf-service;1';
    const RDF_CONTAINER_PROG_ID = '@mozilla.org/rdf/container;1';
    const RDF_DS_PROG_ID        = '@mozilla.org/rdf/datasource;1?name=xml-datasource';

    if (!fileRef.exists()) {
        return;
    }

    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);

    // Interface change - ns7 (mozilla 1.0) needs nsIIOService, latter (mozilla 1.2) needs nsIFileProtocolHandler
    if(Components.interfaces.nsIFileProtocolHandler){
      var fileHandler = ioService.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
      var myFileUrl = fileHandler.getURLSpecFromFile(fileRef);
    } else {
      var myFileUrl = ioService.getURLSpecFromFile(fileRef);
    }

    try {
      var rdf   = C.classes
                  [RDF_SRVC_PROG_ID].getService(C.interfaces.nsIRDFService);

      var ds    = rdf.GetDataSource(myFileUrl);

      var rem   = ds.QueryInterface(C.interfaces.nsIRDFRemoteDataSource);
      if (!rem.loaded) {
        rdf.UnregisterDataSource(ds);
        ds        = C.classes[RDF_DS_PROG_ID].
                    getService(C.interfaces.nsIRDFDataSource);
        rem       = ds.QueryInterface(C.interfaces.nsIRDFRemoteDataSource);
        rem.Init(myFileUrl);
      }
      rem.Refresh(true)
      var rs  = rdf.GetResource(containerName);
      var container = C.classes[RDF_CONTAINER_PROG_ID].
                           getService(C.interfaces.nsIRDFContainer);
      container.Init(rem, rs);

      var el = rdf.GetLiteral(nodeName); // remove if it's a literal
      container.RemoveElement(el, true);
      el = rdf.GetResource(nodeName); // remove it it's a resource
      container.RemoveElement(el, true);
      rem.Flush()
      rem.Refresh(true)
    } catch (e) {
      return;
    }
  }

  function ReadFrom(aFile)
	{
         netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		var stream = Components.classes['@mozilla.org/network/file-input-stream;1'].createInstance(Components.interfaces.nsIFileInputStream);
		stream.init(aFile, 1, 0, false); // open as "read only"

		var scriptableStream = Components.classes['@mozilla.org/scriptableinputstream;1'].createInstance(Components.interfaces.nsIScriptableInputStream);
		scriptableStream.init(stream);

		var fileSize = scriptableStream.available();
		var fileContents = scriptableStream.read(fileSize);

		scriptableStream.close();
		stream.close();

		return fileContents;
  }
  function WriteTo(aFile, aContent)
	{
         netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		if (aFile.exists()) aFile.remove(true);
		aFile.create(aFile.NORMAL_FILE_TYPE, 0666);

		var stream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
		stream.init(aFile, 2, 0x200, false); // open as "write only"

		stream.write(aContent, aContent.length);

		stream.close();
	}

}

function clearCache(aType)
{
	var classID = Components.classes["@mozilla.org/network/cache-service;1"];
	var cacheService = classID.getService(Components.interfaces.nsICacheService);
	cacheService.evictEntries(aType);
}



